/* Copyright (C) 1991, 1992, 1993, 1994, 1995 Free Software Foundation, Inc.
This file is part of the GNU C Library.

The GNU C Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The GNU C Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU C Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.  */

#include <ansidecl.h>
#include <math.h>

#ifdef	__GNUC__

/* Return the base 2 signed integral exponent of X.  */

double
DEFUN(__logb, (x), double x)
{
  if (__isnan (x))
    return x;
  if (__isinf (x))
    return fabs (x);

  if (x == 0.0)
    asm ("flog2%.x %0, %0" : "=f" (x) : "0" (x));
  else
    asm ("fgetexp%.x %0, %0" : "=f" (x) : "0" (x));

  return x;
}

weak_alias (__logb, logb)

#else
#include <sysdeps/ieee754/logb.c>
#endif
